﻿/* En este archivo se recoge la implementación de algunas herramientas de dibujo*/
/* Estas herramientas son:
-lápiz
-texto
-arrastrar símbolo
-guardar
-imprimir */

import mx.utils.Delegate;
import mx.managers.DepthManager;

class HerramientasDibujo extends MovieClip{

	//movieclip sobre el que vamos a pintar
	//private var lienzo:MovieClip;
	private var _cursor:MovieClip;
	private var velocidad:Number;//velocidad a la que se mueve el cursor por la pantalla(para el teclado)
	//coordenadas a las que se va moviendo el cursor y el ratón al 
	//pintar con la herramienta lápiz
	private var xlapiz:Number;
	private var ylapiz:Number;
	
	private var tecla:Number;
	//Pruebas teclado
	
    private function teclaPulsada (eventObj:Object): Void {
		trace ("El primero registrado");
	}
	
	private function teclaPulsada2 (eventObj:Object): Void {
		trace ("El segundo registrado");
	}
	//Pruebas teclado FIN
	
	private function desplazar_cursor (eventObj:Object): Void {
		//esta función desplaza el cursor por la pantalla dependiendo de la tecla que se haya pulsado
		//y activa el pulsado cuando se pulsa el ENTER
		trace ("on Key Down");
		trace (_cursor);
		trace (this);

		tecla = Key.getCode();
		trace ("tecla:"+tecla);
		switch (tecla) {
			case (Key.UP):
				_cursor._y = (_cursor._y - velocidad);
				trace ("_cursor.y:"+_root._cursor._y+"_cursor.x"+_root._cursor._x);
				break;
			case (Key.DOWN):
				_cursor._y = (_cursor._y + velocidad);
				trace ("_cursor.y:"+_root._cursor._y+"_cursor.x"+_root._cursor._x);
				break;
			case (Key.LEFT):
				_cursor._x = (_cursor._x - velocidad);
				trace ("_cursor.y:"+_root._cursor._y+"_cursor.x"+_root._cursor._x);
				break;
			case (Key.RIGHT):
				_cursor._x = (_cursor._x + velocidad);
				trace ("_cursor.y:"+_root._cursor._y+"_cursor.x"+_root._cursor._x);
				break;
			case (Key.SPACE):
				marcarPintado();
		}
	}

	
/***********************************************************************************************/	
/* Herramienta lápiz */
/***********************************************************************************************/	
public function HerramientasDibujo ()
{
	super ();
	//utilizaremos el propio lienzo como escuchador de ratón.
	//establecemos el estilo de la línea
	this.lineStyle(1,0x000000,100);
	//cuando se pulsa el izdo del mouse se llama a marcarPintado
	this.onMouseDown=Delegate.create(this,marcarPintado);
	this.onMouseMove = Delegate.create(this,actualziarCursor);
   //preparamos el propio lienzo como escuchador de teclado
	this.focusEnabled = true;
	this.tabEnabled = true;
	this.onRollOver = Delegate.create(this,establecerFoco);
	//al pulsar una tecla llamamos a desplazar cursor
	//Comentado por prueba teclado
	this.onKeyDown = Delegate.create(this,desplazar_cursor);
	//Añadido por prueba teclado
	/*this.onKeyDown = Delegate.create(this,teclaPulsada);
	Key.addListener (this);*/
    //Fin prueba teclado
	this.onSetFocus = function (eventObj:Object){
			trace("Foco establecido en lienzo");
	}
	this.onKillFocus = function(eventObj:Object){
			trace("perdiendo el foco");
			Selection.setFocus(this);};
	trace ("constructor");
	this._cursor=null;
	//Se pone sobre todo
	this.swapDepths(DepthManager.kTopmost);
	
}
public function setCursor (cursor : MovieClip) : Void
{
	this._cursor = cursor;
	this._cursor.parent = this;
	this._cursor._x=0;
	this._cursor._y=0;
	trace ("Estableciendo el cursor "+ cursor);
}

/*public function HerramientasDibujo (padre:MovieClip, X: Number, Y: Number, Ancho : Number, Alto : Number)
{
	super();
	this._parent = padre;
	this._cursor =null;
	//this.lienzo = null;
	velocidad = 0;
	this.opaqueBackground = 0xCCCCCC;
	this._x=X;
	this._y=Y;
	this._width=Ancho;
	this._height=Alto;
	this._visible = true;
	this.onSetFocus = function (eventObj:Object){
			trace("Foco establecido en lienzo");
		}
}
*/

public function herramienta_Lapiz (arg_lienzo:MovieClip, arg__cursor:MovieClip, arg_velocidad:Number){
		trace("Herramienta Lápiz");
	//Como parámetro recibimos el movieclip sobre el que vamos a pintar y el cursor para el pintado con teclado.
	// asignamos los parametros recibidos, a los atributos de la clase
		_cursor = arg__cursor;
		//lienzo = arg_lienzo;
		velocidad = arg_velocidad;
		trace("_cursor_Arg:"+this);
		trace("_cursor Asignado:"+this._cursor);
	//utilizaremos el propio lienzo como escuchador de ratón.
	//establecemos el estilo de la línea
		this.lineStyle(1,0x000000,100);
	//cuando se pulsa el izdo del mouse se llama a marcarPintado
		this.onMouseDown=Delegate.create(this,marcarPintado);	
	//preparamos el propio lienzo como escuchador de teclado
		this.focusEnabled = true;
		this.tabEnabled = true;
		this.onRollOver = Delegate.create(this,establecerFoco);
			//al pulsar una tecla llamamos a desplazar cursor
		this.onKeyDown = Delegate.create(this,desplazar_cursor);
		//Key.addListener(lienzo);
		this.onSetFocus = function (eventObj:Object){
			trace("Foco establecido en lienzo");
		}
		this.onKillFocus = function(eventObj:Object){
			trace("perdiendo el foco");};
	}
	
	
   private function actualziarCursor(eventObj:Object) : Void{
	   this._cursor._x=_xmouse;
	   this._cursor._y=_ymouse;
	   
   }
	
	private function establecerFoco(eventObj:Object) : Void{
		trace("OnRollOver:"+this);
		if (eventObj.target != this)
		  trace ("Llama alguien que no debe")
		Selection.setFocus(this);
		this.onRollOver = function(){
		trace("OnRollOver");
		}
	}
	
	private function marcarPintado (eventObj:Object): Void{
		trace("marcarPintadoRaton");
		//Como hemos recibido un evento de ratón, las coordenadas iniciales en las que comenzaremos
		//a pintar serán las coordenadas del ratón, por lo que asignamos a xlapiz e ylapiz los valores
		//de las coordenadas de ratón.
		xlapiz = _xmouse;
		ylapiz = _ymouse;
		_cursor._x=_xmouse;
		_cursor._y=_ymouse;
		//updateAfterEvent();
		//cuando lo levanta cuando se levanta el dedo del ratón, ya estamos listos para pintar
		//se llama a la función PintadoActivo 
		//que se encargará de esperar por los eventos de movimiento (tanto de teclado como de ratón)
		this.onMouseUp = Delegate.create(this,comenzarPintadoLapiz);
		this.onKeyDown = Delegate.create(this,pintarTeclado);
	}
	
	private function pintarTeclado (eventObj:Object): Void {
		//en esta función se pinta segun los movimientos del teclado
		//o se desactiva el pintado si se pulsa de nuevo ENTER
		
		this.moveTo(_cursor._x, _cursor._y);

		tecla = Key.getCode();
		trace ("tecla:"+tecla);
		switch (tecla) {
			case (Key.UP):
				_cursor._y = (_cursor._y - velocidad);
				this.lineTo(_cursor._x, _cursor._y);
				trace ("_cursor.y:"+_root._cursor._y+"_cursor.x"+_root._cursor._x);
				break;
			case (Key.DOWN):
				_cursor._y = (_cursor._y + velocidad);
				this.lineTo(_cursor._x, _cursor._y);
				trace ("_cursor.y:"+_root._cursor._y+"_cursor.x"+_root._cursor._x);
				break;
			case (Key.LEFT):
				_cursor._x = (_cursor._x - velocidad);
				this.lineTo(_cursor._x, _cursor._y);
				trace ("_cursor.y:"+_root._cursor._y+"_cursor.x"+_root._cursor._x);
				break;
			case (Key.RIGHT):
				_cursor._x = (_cursor._x + velocidad);
				this.lineTo(_cursor._x, _cursor._y);
				trace ("_cursor.y:"+_root._cursor._y+"_cursor.x"+_root._cursor._x);
				break;
			case (Key.SPACE):
				this.onKeyDown = Delegate.create(this,desplazar_cursor);
		}
	}
	private function comenzarPintadoLapiz (eventObj:Object): Void{
		trace("comenzarPintadoLapiz");
		// situamos el movieClip en las coordenadas iniciales.
		this.moveTo(xlapiz, ylapiz);
		//cuando nos llega un evento de que el ratón se ha movido
		//llamamos a la función pintarLapiz con las nuesvas coordenadas del ratón
		this.onMouseMove = Delegate.create(this,establecerCoordenadasLineaRaton);
		this.onMouseDown = Delegate.create(this,desmarcarPintado);
	}

	private function establecerCoordenadasLineaRaton(eventObj:Object):Void{
		//establece el nuevo punto al que ampliamos la línea que estamos pintando
		//que como hemos llegado a través de un evento de ratón
		//serán las nuevas coordenadas donde hemos desplazado el ratón.
		xlapiz = _xmouse;
		ylapiz = _ymouse;
		_cursor._x=_xmouse;
		_cursor._y=_ymouse;
		//updateAfterEvent();
		//llamamos la la función pintarLinea para pintarla
		pintarLinea(xlapiz, ylapiz);
	}	

	private function pintarLinea (x:Number, y:Number){
		trace("pintarLinea");
		// ponemos en xlapiz e ylapiz las nuevas coordenadas y trazamos un línea hasta ellas
		this.lineTo(x,y);
	}
	
	private function desmarcarPintado(eventObj:Object):Void{
		trace("desmarcarPintado");
		//para el pintado cuando se mueve el ratón
		//y prepara para cuando se vuelva a pulsar el ratón comenzar de nuevo el pintado
		this.onMouseMove = Delegate.create(this,null);
		this.onMouseDown= Delegate.create(this,marcarPintado);
		this.onMouseUp = Delegate.create(this,null);
	}
	
	
/***********************************************************************************************/	
/*Fin Pintar con Herramienta Lapiz*/
/***********************************************************************************************/	

/***********************************************************************************************/	
/*Formas*/
/***********************************************************************************************/
/*En esta sección se implementará el código de las formas: 
cuadrado, círculo, rectángulo y triángulo*/


/***********************************************************************************************/	
/*Fin Formas*/
/***********************************************************************************************/	
	
}