﻿class configuracion.GestorGrupos extends MovieClip{
	private var _debug:Boolean = false;
	private var _posDentroGrupo:Number;
	private var _grupos:Array; //Lista de los grupos registrados
	private var gEvAct:Object;
	private var _padre:Object;
	private var _destino:String;
	//Javier Cuesta // Añadido para probar el paso de un grupo a otro
	private var _listaGrupos:Array;
	private var indiceGrupos:Number;
	// Fin
	public var _grupoBloqueado:String;
	public var bloqueoGrupo:Boolean;

	public var _maestro:Object; //Desbloquear los grupos a petición, para recorrer la actividad completa
	public var _retro_maestro:Object;
	
	public var barra: String;
	public var marcaBarra : Boolean;
	//Hace falta  la def de este atributo para que al hacer addProperty la chapuza del _maestro tenga también un atributo gGrupos
	private var gGrupos :configuracion.GestorGrupos;
	
	//Método constructor de la clase.
	//Donde notificar_a sera el objeto llamante y el padre el gestor de accesibilidad, que es el que lo crea
	function GestorGrupos (notificar_a, padre) {
		gEvAct = notificar_a;
		_padre = padre;
		_posDentroGrupo = 0;
		//Inicializo el bloqueo de grupos a falso
		bloqueoGrupo = false;
		_grupos = new Array();
		//Javier Cuesta //añadido pasar al siguiente grupo con el maestro
		indiceGrupos = 0;
		_listaGrupos = new Array();
		//Fin
		//gGrupos=this;
		_maestro = new Object();
		_maestro.addProperty("gGrupos");
		_maestro.gGrupos = this;
		_maestro._listaGrupos = new Array();
		this._listaGrupos=_maestro._listaGrupos;
		_maestro.alPulsar = avanceGrupo;
		
		_retro_maestro = new Object();
		_retro_maestro.addProperty("gGrupos");
		_retro_maestro.gGrupos = this;
		_retro_maestro.alPulsar = retrocesoGrupo;
		Selection.addListener(this);
	}

	public function getPadre(){
		return _padre;
	}

	public function inicializarGrupos (objetos:Array) {
		if(_debug) trace("Agrupando...");
		for (var i=0;i<objetos.length;i++){
		if(_debug) trace("Objeto: " + objetos[i].objeto);
			if (objetos[i].grupo != undefined){
				if(_debug) trace("pasando " + objetos[i].grupo + " a " + gEvAct[objetos[i].objeto] + "?");
				gEvAct[objetos[i].objeto].grupo = objetos[i].grupo;
			}
			if(_debug) trace(gEvAct[objetos[i].objeto].grupo + "?");
		}
	}

    public function avanceGrupo (){
			//Javier Cuesta
			//El maestro es un gestor de grupos, con las mismas propiedades que el propio gestor de grupos
			//para poder saltar de un grupo a otro he creado una lista del tipo "tipoGrupo" que almacena el nombre de los grupos
			//en el mismo orden que se reciben del XML de configuración y un atributo "desactivo" que indica si el grupo está operativo,
			if(_debug) trace("PULSADO MAESTRO");//El maestro es el tabulador
			var actual:MovieClip = eval(Selection.getFocus());
			if(_debug) trace(actual.grupo + "=?" + this._grupoBloqueado);
			var proximo: String;
			var grupo_proximo: configuracion.tipoGrupo;
			var res:Boolean = false;
			//recorro la lista de grupos comprobando si estan activos o no, de esta forma al pulsar el maestro pasaremos al siguiente grupo "activo"
			while (!res){
				if (gGrupos.indiceGrupos < this._listaGrupos.length -1){
					grupo_proximo = this._listaGrupos[gGrupos.indiceGrupos+1];
					gGrupos.indiceGrupos++;
				}
				else{
					grupo_proximo = this._listaGrupos[0];
					gGrupos.indiceGrupos = 0;
				}
				if (!grupo_proximo.darDesactivo()){
					proximo = grupo_proximo.darNombre();
					res = true;
				}
			}
			this.gGrupos.irA(proximo,true);
		}

	public function retrocesoGrupo (){
			//Javier Cuesta
			//El maestro es un gestor de grupos, con las mismas propiedades que el propio gestor de grupos
			//para poder saltar de un grupo a otro he creado una lista del tipo "tipoGrupo" que almacena el nombre de los grupos
			//en el mismo orden que se reciben del XML de configuración y un atributo "desactivo" que indica si el grupo está operativo,
			trace("he retrocedido de grupo y lista de maestro es :"+gGrupos._listaGrupos);			
			if(_debug) trace("PULSADO MAESTRO");//El maestro es el tabulador
			var actual:MovieClip = eval(Selection.getFocus());
			if(_debug) trace(actual.grupo + "=?" + this._grupoBloqueado);
			var proximo: String;
			var grupo_proximo: configuracion.tipoGrupo;
			var res:Boolean = false;
			//recorro la lista de grupos comprobando si estan activos o no, de esta forma al pulsar el maestro pasaremos al siguiente grupo "activo"
			while (!res){
				if (gGrupos.indiceGrupos >0){
					grupo_proximo = gGrupos._listaGrupos[gGrupos.indiceGrupos-1];
					gGrupos.indiceGrupos--;
				}
				else{
					grupo_proximo = gGrupos._listaGrupos[gGrupos._listaGrupos.length -1];
					gGrupos.indiceGrupos = gGrupos._listaGrupos.length -1;
				}
				if (!grupo_proximo.darDesactivo()){
					proximo = grupo_proximo.darNombre();
					res = true;
				}
			}
			this.gGrupos.irA(proximo,true);
		}
	
	//Este método cambia el foco de un determinado grupo a otro
	public function onSetFocus (viejo:Object, nuevo:Object) {
//			_level100.log.htmlText += "VF:" + viejo.grupo + " - NF:" + nuevo.grupo;
		//Compruebo si se ha producido un cambio de grupo
		if ((viejo.grupo != nuevo.grupo) and (viejo.grupo != undefined)){
			if (bloqueoGrupo){
				//_destino controla a dónde iré cuando saga del grupo actual.
				if(_debug) trace("Cambio: " + viejo.grupo + " -> " + nuevo.grupo + "(" + this.barra +")");
				if(_debug) trace("D: " + _destino + ", GB: " + _grupoBloqueado);
				//Juego con _destino para ver a dónde voy.
				if (_destino == _grupoBloqueado){
					if (nuevo.grupo != _grupoBloqueado){
						//Quiero ir al grupo bloqueado
						irA(_grupoBloqueado, bloqueoGrupo);
					}
				}
			}
			gEvAct.Notificar(nuevo,"cambio grupo",new Array(viejo.grupo,nuevo.grupo));
		}
		//Tengo que saber si he pisado un elemento bloqueado
		if (nuevo.bloqueado==true){
			if (nuevo.tabIndex > viejo.tabIndex){
				_padre.gBarridos.avanzar();
			}
			else{
				_padre.gBarridos.retroceder();
			}
		}
	}
	
	//Este método inserta un nuevo grupo en la lista de grupos
	public function registrarGrupo(nombre:String, lista:Array){
		//Para todos los elementos de la lista les asigno el grupo
		if (_grupos[nombre] != undefined){
			if(_debug) trace("ERROR: el grupo " + nombre + "ya existe");
		}
		else{
			for(var i=0;i<lista.length;i++){
				gEvAct[lista[i]].grupo = nombre;
				_grupos[nombre][lista[i].tabIndex] = lista[i];
			}
		}
	}
	
	//Este método se usa para liberar un grupo que ya no se vuelve a utilizar
	//Post: elimina el grupo pasado como parámetro de la lista de grupos.
	public function liberarGrupo(nombre){
		if (_grupoBloqueado == nombre){
			bloqueoGrupo = false;
			_grupoBloqueado = undefined;
		}
		//Elimino un grupo
		for(var i=0;i<_grupos[nombre].length;i++)
			gEvAct[_grupos[nombre][i]].grupo = undefined;
		_grupos[nombre] = undefined;
	}
	
	//Javier Cuesta
	//Este método nos pernite poder desactivar un determinado grupo que ha sido registrado en una actividad
	//Si ha este método se le llama desde la propia actividad (.fla) habrá que llamarlo una vez se haya finalizado la carga
	//del gestor de accesibilidad
	public function desactivarGrupo (nombre:String){
		var aux: configuracion.tipoGrupo;
		for(var i=0;i<_maestro._listaGrupos.length;i++){
			aux = _maestro._listaGrupos[i];
			if (_maestro._listaGrupos[i].darNombre() == nombre){
				_maestro._listaGrupos[i].desactivar();
				break;
			}
		}
	}

	//Javier Cuesta
	//Este método nos pernite poder activar un determinado grupo que ha sido registrado en una actividad
	//Si ha este método se le llama desde la propia actividad (.fla) habrá que llamarlo una vez se haya finalizado la carga
	//del gestor de accesibilidad
	//NOTA: este método no hay que utilizarlo si no se ha descactivado manualmente (con el método "desactivarGrupo")
	//ya que el constructor de la clase lo pone "activo" por defecto.
	public function activarGrupo (nombre:String){
		var aux: configuracion.tipoGrupo;
		for(var i=0;i<_maestro._listaGrupos.length;i++){
			aux = _maestro._listaGrupos[i];
			if (_maestro._listaGrupos[i].darNombre() == nombre){
				_maestro._listaGrupos[i].activar();
				break;
			}
		}
	}

	//Añado un elemento a un grupo. Si no existe el grupo, me quejo.
	//Si grupo es undefined, lo meto en el básico??? el básico puede ser automático
	public function insertar(obj:Object, grupo:String){
		obj.grupo = grupo;
		if (_grupos[grupo] == undefined){
			if(_debug) trace("    Grupo no encontrado. Creando grupo: " + grupo + ".");
			//Javier Cuesta
			// inserto el nuevo grupo en la lista de grupos registrados por el maestro
			var aux:configuracion.tipoGrupo = new configuracion.tipoGrupo(grupo);
			_maestro._listaGrupos.push(aux);
			_grupos[grupo] = new Array();
		}
		//Meto el objeto en el desplazamiento tabIndex de su grupo
		_grupos[grupo][obj.tabIndex] = obj;
		_padre.desbloquear([obj]);
		if(_debug) trace("    " + _grupos[grupo][obj.tabIndex] + " (" + obj.tabIndex + ") en grupo: " + _grupos[grupo][obj.tabIndex].grupo);
	}
	
	//Este método extrae un determinado objeto accesible de un grupo
	public function extraer(obj:Object, grupo:String){
		//Busco el objeto en el grupo, y lo quito...
		for (var i=0; i< _grupos[grupo].length;i++){
			if (_grupos[grupo][i] == obj){
				_padre.bloquear([_grupos[grupo][i]]);
				_grupos[grupo][i] = undefined; //porque los grupos están organizados por tabIndex
			}
		}
		obj.grupo = undefined;
	}
	
	//Devuelvo si está o no en el grupo indicado
	public function estaEn(obj:Object, grupo:String):Boolean{
		return (obj.grupo == grupo);
	}
	
	//Javier Cuesta 12-11-08
	//Este método bloquea un grupo y desbloquea el resto, es decir, 
	//en un momento dado sólo puede haber un grupo bloqueado
	public function bloquearGrupo (nombre: String){
		var aux: configuracion.tipoGrupo;
		//Si el nombre es undefined, desbloquea todos los grupos
		if(nombre == undefined){
			for(var i=0;i<_maestro._listaGrupos.length;i++){
				_maestro._listaGrupos[i].desbloquear();
			}
		}
		else{
			for(var i=0;i<_maestro._listaGrupos.length;i++){
				aux = _maestro._listaGrupos[i];
				if (_maestro._listaGrupos[i].darNombre() == nombre){
					_maestro._listaGrupos[i].bloquear();
				}
				else{
					_maestro._listaGrupos[i].desbloquear();
				}
			}
		}
	}
	
	//Javier Cuesta 12-11-08
	//Este método nos devuelve el grupo que hay bloqueado en un momento dado
	public function darGrupoBloqueado ():String{
		var aux: configuracion.tipoGrupo;
		for(var i=0;i<_maestro._listaGrupos.length;i++){
			aux = _maestro._listaGrupos[i];
			if (_maestro._listaGrupos[i].darBloqueado()){
				return _maestro._listaGrupos[i].darNombre();
			}
		}
		return undefined;
	}

	//Javier Cuesta 
	//Este método todavía no se usa, lo utilizaremos para avanzar dentro de un grupo
	//cuando la getsion se haga en este gestor
	public function avanzarEnGrupo ():MovieClip{
		var grupo: String = darGrupoBloqueado();
		if(_debug) trace("AVANZANDO...");
		if (_posDentroGrupo == _grupos[grupo].length-1){
			_posDentroGrupo = 0;
		}
		else{
			_posDentroGrupo++;
		}
		while (_grupos[grupo][_posDentroGrupo] == undefined){
			if (_posDentroGrupo==_grupos[grupo].length-1){
				_posDentroGrupo = 0;
			}
			else{
				_posDentroGrupo++;
			}
		}
		return _grupos[grupo][_posDentroGrupo];
	}
	
	//Este método es utilizado para ir a un grupo determinado de los grupos registrados.
	//Pre: es necesario indicar el nombre del grupo como parámetro
	//Post: hace un cambio de grupo al grupo pasado como parámetro, 
	//si le pasamos "undefined" no cambiamos de grupo pero quitamos el foco del grupo actual
	public function irA(grupo:String, bloquear_grupo:Boolean, posDentroGrupo:Number){
		_destino = grupo;
		if (posDentroGrupo == undefined)
			_posDentroGrupo = 0;
		else
			_posDentroGrupo = posDentroGrupo;

		if(grupo == undefined){
			if(_debug) trace("Grupo no definido");
			bloquearGrupo(undefined);
			_padre.gBarridos.irA(undefined);
			return;
		}

		//Me quejo si no existe. 
		if (_grupos[grupo] == undefined){
			if(_debug) trace("El grupo no está registrado");
			return;
		}

		//Pongo el foco en el tabIndex correspondiente al elemento que me pasan,
		//si no me pasan ninguno, en el más bajo del grupo
		if(_debug) trace("Solicitado ir al grupo " + grupo + "(" + _grupos[grupo].length + ")");
		if(_debug) trace("grupo:" + grupo);
		if(_debug) trace("padre:" + _padre);
		for (var i=0;i< _maestro._listaGrupos.length;i++){
			if ((_maestro._listaGrupos[i].darNombre())==grupo){
				if (posDentroGrupo == undefined)
					indiceGrupos = i;
				else
					indiceGrupos = i + posDentroGrupo;
			}
		}
		
		for (var i=0;i< _grupos[grupo].length;i++){
			//i lleva el tabIndex del objeto pasado
			if (_grupos[grupo][i]!=undefined){
				//Y bloqueo el grupo, si es menester
				if (bloquear_grupo != undefined)
					_grupoBloqueado = grupo;
				bloqueoGrupo = bloquear_grupo;
				//bloqueo el grupo en la lista de grupos del maestro
				bloquearGrupo(grupo);
				if (posDentroGrupo == undefined)
					_padre.gBarridos.irA(i);
				else
					_padre.gBarridos.irA(i+ posDentroGrupo);
				
				break;
			}
		}
		return;
	}	
	
	public function irABarra(){
		//Si barra no está bien definido, lo mando al principio
		marcaBarra = true;
		if (barra == undefined){
		if(_debug) trace("Solicitado ir al principio");
			_padre.gBarridos.irA(0);
			return;
		}
		//Pongo el foco en el tabIndex más bajo del grupo BARRA
		if(_debug) trace("Ir al grupo " + barra + "(" + _grupos[barra].length + ")");
		//_transicion = true;
		_destino = barra;
		for (var i=0;i< _grupos[barra].length;i++){
			//i lleva el tabIndex del objeto pasado
			if (_grupos[barra][i]!=undefined){
				_padre.gBarridos.irA(i);
			//_padre.gBarridos.retroceder();
				break;
			}
		}
		return;
	}
	
	private function notificarAbandono(grupo:String){
		if(_debug) trace("Notificando abandono de grupo" + grupo);
		gEvAct.Notificar(grupo,"abandono");
	}
}