﻿import configuracion.datatypes.TCombinacion;
class configuracion.datatypes.MetodosAbreviados
{
	static private var listaTeclas:Array;
	
	//Variables que agilizan 
	private var baseOtros = 32;
	private var listaOtros = ["Barra Espaciadora","Re Pág","Av Pág","Fin","Inicio","Flecha izquierda","Flecha arriba","Flecha derecha","Flecha abajo"]
	private var baseNumeros = 48;
	private var listaNumeros = ["0","1","2","3","4","5","6","7","8","9"];
	private var baseLetras = 65;
	private var listaLetras = ["A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y","Z"]
	private var baseFuncion = 112;
	private var listaFuncion = ["F1","F2","F3","F4","F5","F6","F7","F8","F9","F10","F11","F12","F13","F14","F15"]
	
	function MetodosAbreviados(){
		var i:Number;
		var j:Number;
		listaTeclas = new Array();
		listaTeclas[8] = "Retroceso";
		listaTeclas[9] = "Tabulador";
		listaTeclas[12] = "Borrar";
		listaTeclas[13] = "Intro";
		listaTeclas[16] = "Mayús";
		listaTeclas[17] = "Control";
		listaTeclas[18] = "Alt";
		listaTeclas[20] = "Bloq Mayús";
		listaTeclas[27] = "Esc";
		i=baseOtros;
		for (j=0;j<listaOtros.length;j++){
			listaTeclas[i+j]=listaOtros[j];
		}
		i=baseNumeros;
		for (j=0;j<listaNumeros.length;j++){
			listaTeclas[i+j]=listaNumeros[j];
		}
		listaTeclas[45] = "Insert";
		listaTeclas[46] = "Supr";
		listaTeclas[47] = "Ayuda";
		i=baseLetras;
		for (j=0;j<listaLetras.length;j++){
			listaTeclas[i+j]=listaLetras[j];
		}
		//No contemplo el teclado numérico
		i=baseFuncion;
		for (j=0;j<listaFuncion.length;j++){
			listaTeclas[i+j]=listaFuncion[j];
		}
		listaTeclas[144] = "Bloq Num";
		//No contemplo los símbolos
//		trace(listaTeclas);
	}
	
	function teclaAString(codTecla:Number):String {
		//Miro si es un número
		return listaTeclas[codTecla];
	}
	
	function stringATecla(str:String):Number {
		var i:Number;
		if (str == undefined)
			return undefined;
		for(i=0;i<listaTeclas.length;i++)
			if (listaTeclas[i].toLowerCase() == str.toLowerCase())
				return i;

	}

	//Devuelve un objeto de tipo
	function cadenaATeclas(cad:String):TCombinacion {
		var n:Number;
		var teclas:Array = new Array();
		//Primero separo la cadena buscando el caracter '+' y aseguro que salen hasta 3 elementos
		var parcial:String = cad;
		var i:Number = parcial.indexOf("+");
		var j:Number = 0;
		while ((i != -1) and (j < 3)){
			//Establezco un desplazamiento según la cantidad de espacios delante y detrás del símbolo '+'
			var nEspaciosDelante = 0; //"_"
			var nEspaciosDetras = 1;  //"+_"
			n = 1;
			while (parcial.charAt(i-n) == " "){
				nEspaciosDelante++;
				n++;
			}
			n = 1;
			while (parcial.charAt(i+n) == " "){
				nEspaciosDetras++;
				n++;
			}
			teclas[j] = parcial.slice(0,i-nEspaciosDelante); //Extraigo la cadena de tecla
			parcial = parcial.slice(i+nEspaciosDetras); //Limpio el resto del string de entrada
			i = parcial.indexOf("+"); //Busco el siguiente símbolo
			j++; //Incremento el índice del array de teclas
		}
		teclas[j] = parcial;
		//Ahora genero el objeto que devolveré. Es un objeto Combinación (.tecla1 , .tecla2, .tecla3)
		return new TCombinacion(stringATecla(teclas[0]),
								stringATecla(teclas[1]),
								stringATecla(teclas[2]),
								cad);
	}
}