﻿/*	Clase Xml2Object
	Esta clase realiza la extraccion de datos de un archivo XML.
*/

import configuracion.xmlcnice.ParserXML;

class configuracion.xmlcnice.Xml2Object
{
	//Atributos publicos de la clase
	public var datum:Array; 
	public var archiveToLoad:String;
	public var onLoad:Function;
	public var _referrer:Object;

	//Atributos privados de la clase
	private var _myParser:ParserXML;

	//Constructor de la clase
	public function Xml2Object()
	{
		init.apply(this,arguments);
	}

	//init()
	private function init()
	{
		datum = new Array();
		_myParser = new ParserXML();
	}
	
	//load(archive, referrer)
	public function load(archive:String, referrer:Object)
	{
		_referrer = referrer;
		archiveToLoad = archive;
		_myParser.init(datum, _onLoad, this);
		_myParser.load(archiveToLoad);
	}

	//_onLoad()
	private function _onLoad()
	{
		delete _myParser;
		onLoad.call(this);
	}
}
