﻿/*	Clase creditos
	Autor: Javier Cuesta Gonzalez de la Aleja
	Fecha: 13 de Abril de 2009
 */

import configuracion.GestorAccesibilidad;

class creditos
{//Clase creditos

	private var _debug:Boolean = false;
	//Atributos privados de la clase
	private var _ventana:MovieClip;
	private var _cargada:Boolean;
	private var _oculta:Boolean;
	private var _gestorAccesibilidad:GestorAccesibilidad;

	//Constructor de la clase
	public function creditos()
	{
		_cargada = false;
	}

	//cargar(gestorAccesibilidad)
	public function cargar(gestorAccesibilidad:GestorAccesibilidad)
	{
		_gestorAccesibilidad = gestorAccesibilidad;
	}

	//enlazarVentana(ventana)
	public function enlazarVentana(ventana:MovieClip)
	{
		_ventana = ventana;
	}

	//onLoadInit(mc)
	function onLoadInit(mc:MovieClip)
	{
		//Ventana cargada y primer fotograma ejecutado
		mostrarVentanaAux();
	}

	//estaVentanaOculta():Boolean
	public function estaVentanaOculta():Boolean
	{
		return _oculta;
	}

	//estaVentanaCargada():Boolean
	public function estaVentanaCargada():Boolean
	{
		return _cargada;
	}

	//mostrarVentana()
	public function mostrarVentana(escena:Number, alTerminar:String)
	{
		if(_debug) trace("*** Mostrando la ventana de creditos");
		if(!_cargada)
		{
			var cargador:MovieClipLoader = new MovieClipLoader();
			cargador.addListener(this);
			cargador.loadClip(_gestorAccesibilidad.obtenerRuta() + "../lib/creditos.swf", 400);
			//Ventana de creditos
			_cargada = true;
		}
		else
		{
			mostrarVentanaAux();
		}
	}

	//mostrarVentanaAux()
	private function mostrarVentanaAux()
	{
		Selection.setFocus(_ventana.etiqueta2);
		_ventana._visible = true;
		_oculta = false;	
	}

	//ocultarVentana()
	public function ocultarVentana()
	{
		if(_debug) trace("*** Ocultando ventana de creditos");
		_ventana._visible = false;
		_oculta = true;
	}

}//Clase creditos
