﻿//clase elementoActividad
//Autor: Javier Cuesta González de la Aleja
//esta clase será utilizada por el gestorEmparejamientos, 
//los elementos que tengamos que utilizar en algunas actividades 
//serán de esta clase, la información que guardaremos de cada 
//elemento será su identificador, el nombre, su significado y el movieclip asociado.

class elementoActividad {
	private var _id:String;
	private var _nombre:String;
	private var _visitado: Boolean;
	private var _significado:String;
	private var _mc:MovieClip;
	private var _grupo: String;
	private var _fichero: String; // archivo swf correspondiente si existe
	//constructora de la clase elementoActividad.
	public function elementoActividad(id:String, nombre:String, significado :String, grupo: String, fichero: String){
		this._id = id;
		this._nombre = nombre;
		this._significado = significado;
		this._mc = null;
		this._visitado = false;
		this._grupo = grupo;
		this._fichero = fichero;
		}
	//devuelve la ruta del fichero swf del objeto
	public function GetFichero():String{
		return this._fichero;
		}
	//devuelve el identificador del objeto
	public function GetId():String{
		return this._id;
		}
	//devuelve el grupo al que pertenece el objeto
	public function GetGrupo():String{
		return this._grupo;
		}
	// devuelve el nombre del objeto.	
	public function GetNombre():String{
		return this._nombre;
		}
	// devuelve el nombre del objeto.	
	public function GetVisitado():Boolean{
		return this._visitado;
		}
	// devuelve el significado del objeto.
	public function GetSignificado():String{
		return this._significado;
		}
	//devuelve el movieclip asociado a ese objeto.
	public function GetMovieClip():MovieClip{
		return this._mc;
		}
	public function PutSignificado(sig:String){
		this._significado = sig;
		}
	public function PutVisitado(){
		this._visitado = true;
		}
	public function PutMovieClip(mc:MovieClip){
		this._mc = mc;
		}
}//Fin elementoActividad
	