﻿//import HerramientaBocadillo;

class HerramientaReedicion {

	private var reeditables:Array = new Array;
	private var lienzo:MovieClip;
	private var cursor:MovieClip;

	public function Herramienta(){
	}
	
	public function AñadirElemento (elemento:MovieClip, instancia:String){
	//añade al array de elementos reeditables un nuevo elemento en la última posición
	//necesito conocer tanto el elemento (para reconocer que he pulsado escribir)
	//como la instancia a la que está asociado (para que haga instancia.reeditar)
		//reeditar contiene una tupla con el elemento y su instancia que será lo que después
		//insertemos en el array de reeditables
		trace ("Añadir Elemento" + instancia);
		var nombre: String;
		var reeditar:Array = new Array;
		//posición de reeditables en la que voy a insertar el nuevo elemento
		var posicion:Number;
		reeditar[0] = elemento;
		//nombre = "herramientaBocadillo"+instancia;
		reeditar[1] = instancia;
		
		posicion = reeditables.length;
		trace ("posicion" + posicion);
		reeditables[posicion] = reeditar;
	}
	
	public function BorrarElemento (elemento:MovieClip){
		var i:Number = 0;
		var reeditar:Array;
		var elem:MovieClip;
		
		for (i==0; i<reeditables.length; i++){
			reeditar = reeditables[i];
			elem = reeditar[0];
			if (elem._name == elemento._name){
				//elimino un elemento desde la posición i
				reeditables.splice(i,1);
			}
		}
	}
	
	public function modoReedicionOn (lienzo:MovieClip,raton:Boolean,velocidad:Number){
	//establece los escuchadores de todos los elementos del array de reedición
		var reeditar:Array;
		var elemento:MovieClip;
		var nombre:String;
		trace ("lienzo:"+lienzo);
		trace("modoReedicionOn" + reeditables.length);
		var Cursor2:Object = new Object;
		cursor = lienzo.attachMovie("Símbolo 30", "cursor",lienzo.getNextHighestDepth());
		Mouse.hide();
		
		var i:Number = 0;
		var encontrado:Boolean = false;

		if (raton == true){
			
			lienzo.onMouseMove = function() {
				Cursor2.x = (_xmouse);
				Cursor2.y = (_ymouse);
				this.globalToLocal(Cursor2);	
				cursor._x = Cursor2.x;
				cursor._y = Cursor2.y;
			}
			
			for (i==0; i<reeditables.length; i++){
				trace ("Entra " + i + "veces");
				reeditar = reeditables[i];
				elemento = reeditar[0];
				nombre = reeditar[1];
				trace ("EN EL BUCLE" + i + " " + elemento + nombre);
				elemento.nombre = nombre;
				elemento.onMouseDown = function (){
					if (encontrado == false){
					if (this.hitTest(_xmouse, _ymouse)){
						trace ("ESTOY SOBRE EL BOCADILLO" + this + this.nombre);
						this._parent.cursor._visible = false;
						_root[this.nombre].reeditarBocadillo(this);
						encontrado = true;
						trace ("encontrado" + encontrado);
					}
					}
				}
			}
		}
		else {
			lienzo.reeditables = reeditables;
			lienzo.onKeyDown = function(){
				var tecla:Number;
				tecla = Key.getCode();
				switch (tecla) {
					case (Key.UP):
						cursor._y = cursor._y - velocidad;
						break;
					case (Key.DOWN):
						cursor._y = cursor._y + velocidad;
						break;
					case (Key.LEFT):
						cursor._x = cursor._x - velocidad;
						break;
					case (Key.RIGHT):
						cursor._x = cursor._x + velocidad;
						break;
					case (Key.SPACE):
						i = 0;
						while((i<lienzo.reeditables.length) and (encontrado == false)){
							reeditar = lienzo.reeditables[i];
							elemento = reeditar[0];
							nombre = reeditar[1];
							trace("Pulsa Espacio" + elemento);
							if ((cursor._x > elemento._x) and 
								(cursor._x < elemento._x + elemento._width) and
								(cursor._y > elemento._y) and 
								(cursor._y < elemento._y + elemento._height)){
									trace ("ESTOY SOBRE EL BOCADILLO" + this + elemento);
									_root[nombre].reeditarBocadillo(elemento);
									encontrado = true;
							}
							i++;
						}
						break;
				}
			}
			Key.addListener(lienzo);
		}
	}
	
	public function modoReedicionOff (lienzo:MovieClip){
	//elimina los escuchadores de todos los elementos del array de reedición
		var reeditar:Array;
		var elemento:MovieClip;
		
		cursor.removeMovieClip();
		Key.removeListener(lienzo);
		Mouse.show();
		
		var i:Number = 0;
		for (i==0; i<reeditables.length; i++){
			trace ("Entra " + i + "veces");
			reeditar = reeditables[i];
			elemento = reeditar[0];
			elemento.onMouseDown = function (){};
		}
	}

}