﻿class configuracion.datatypes.Subtitulos extends Object{
	private var _debug:Boolean = false;

	private var _textBox_mc:MovieClip;
	public var _objRefuerzo:MovieClip;
	private var _textShown:Array;  //Lista de textos
	public var _currentIndex:Number;
	private var _idTipBox:Number;
	private var _delay:Number;
	private var stopOnFinish:Boolean = new Boolean(false);
	private var terminado:Boolean = new Boolean(false);
	private var terminadoParcial:Boolean = new Boolean(false);
	public var subtitulos:Boolean = new Boolean(true);
	public var onFinish:Function;
	public var onFrase:Function;
	public var _limpiar: Boolean = new Boolean(false);
//	private var _retraso:Number;
	private var _iterador:Number;
	private var _locuciones:Array; //Lista de locuciones
	private var _sonido:Sound;
	private var volumen:Number;
	private var sonidoError:Boolean;
	public var pos_sonido:Number = 0;
	private var pulsado_pause:Boolean = false
	private var pulsado_stop:Boolean = false;
	private var retroceso_index:Boolean = false;
	private var repeticion:Boolean = false;
//	private var loLlamaSetText:Boolean = new Boolean(false);
	//Faraco 26-11-08
	private var _subsActivados:Boolean;
	private var _audioActivado:Boolean;
	//Fin Faraco 26-11-08
	public var animarMascota:Boolean = new Boolean(true);
	
	public var gSincro:Object; //Este es el GestorSincro llamante
	
	public function Subtitulos(padre:Object) {
		gSincro = padre;
		onFinish = undefined;
		onFrase = undefined;

		this._sonido.prototype.addProperty("pr");
		this._sonido = new Sound();
		this._sonido.onLoad = function(success){
			if(_debug) trace("!!!RESULTADO DE LA CARGA: " + success);
			if (not success){
				if(_debug) trace("ERROR EN LA CARGA!!");
				_level0.sonidoError = true;
			}
			else{
				if(_debug) trace("CARGA CORRECTA!!");
				_root.gAcces.gSincro.gSubtitulos.duracion_acum = this.duration; 
				_root.gAcces.gSincro.gSubtitulos.pos_parcial = this.position;
				_level0.sonidoError = false;
				//Faraco 15-10-2008
				if(_level100.gAcces.gSincro.gSubtitulos.animarMascota){
					_level100.gAcces.gSincro.gSubtitulos._objRefuerzo.cargarAccion("hablando");
				}
				//Fin Faraco 15-10-2008
			}
		}

		this.volumen = gSincro.getPadre().gConfig.GetVolumen();
		this._sonido.setVolume(this.volumen);

		//Faraco 26-11-08
		this._subsActivados = gSincro.getPadre().gConfig.GetSubtitulos();
		this._audioActivado = gSincro.getPadre().gConfig.GetLocuciones();
		//Fin Faraco 26-11-08
	}
	public function darIndex ():Number{
		return this._currentIndex;
	}
	public function pause (subtitulos: Boolean){
		this.pulsado_pause = true;
		this.pos_sonido = 0;
		_sonido.stop();
		if (subtitulos != undefined){
			_textBox_mc.htmlText = "";
		}
	}
	public function stop (){
		this.pulsado_stop = true;
		_sonido.stop();
		_textBox_mc.htmlText = "";
	}
	
	public function play (){
		trace("pulsado pause es: "+pulsado_pause);
		trace("pulsado stop es: "+pulsado_stop);
		if (pulsado_pause){
			this.pulsado_pause = false;
			repetir();
			//_sonido.loadSound(_locuciones[_currentIndex], true); //Lo cargo como streaming
			//this._sonido.setVolume(this.volumen);
			this.gSincro._padre.gEvAct.Notificar(_sonido,"FIN_PAUSE");
		}
		if (pulsado_stop){
			this.pulsado_stop = false;
			this.gSincro._padre.gEvAct.Notificar(_sonido,"FIN_STOP");
		}
	}
	
	public function avanzar (){
		var long:Number = _locuciones.length;
		if (_currentIndex <= long-1){
			if (_currentIndex > 0){
				finAudio();
			}
		}
	}
	
	public function retroceder (){
		var long:Number = _locuciones.length;
		//_sonido.stop();
		if (long == 1){
			setText(_textShown,_locuciones,null,true);
		}
		else{
			if (terminado){
				retroceso_index = true;
				_currentIndex = long-2;
				trace("estoy llamando a setText con currentIndex: "+_currentIndex);
				setText(_textShown,_locuciones,null,true);
			}
			else{
				if (_currentIndex > 1){
					_currentIndex--;
					_currentIndex--;
					finAudio();
				}
			}
		}
	}
	
	public function repetir (){
		var long:Number = _locuciones.length;
		if (long == 1){
			setText(_textShown,_locuciones,null,true);
		}
		else{
			if (terminado){
				retroceso_index = true;
				_currentIndex = long-1;
				repeticion = true;
				setText(_textShown,_locuciones,null,true);
			}
			else{
				if (_currentIndex >= 1){
					_currentIndex--;
					finAudio();
				}
			}
		}
	}
	
	public function registrarTextBox(textBox_mc:MovieClip, delay:Number, objRefuerzo:MovieClip) {
		if (_idTipBox > 0) clearInterval(_idTipBox);
		_textBox_mc = textBox_mc;
		_textShown = new Array();
		_currentIndex = 0;
		_idTipBox = new Number();
		if(delay != undefined)
		{
			_delay = delay;
		}
		if(objRefuerzo != undefined)
		{
			_objRefuerzo = objRefuerzo;
		}
		if(_debug) trace("Registrado textBox: " + _textBox_mc);
	}

	public function setDelay(delay:Number)
	{
		_delay = delay;
	}

	public function setVolumen(volumen:Number)
	{
		this.volumen = volumen;
	}

	public function setText(textToShow:Array, locuciones:Array, delay:Number, _stopOnFinish) {
		_sonido.stop();
		clearInterval(_idTipBox);
		
		if (not repeticion){
			terminado = false;
		}
/*		if (_idTipBox > 0){
			if(_debug) trace("limpiando");
			clearInterval(_idTipBox);
		}
*/
		if ((delay == undefined) or (delay == null)) 
			delay = _delay;

		if(_stopOnFinish == undefined)
			stopOnFinish = true; //Predefinido no se para al final
		else
			stopOnFinish = _stopOnFinish;

		_textShown = textToShow;
		_locuciones = locuciones;
		if (retroceso_index){
			retroceso_index = false;
			}
		else{
			_currentIndex = 0;
		}
		if(_debug) trace ("currentIndex "+ _currentIndex)
		if(_subsActivados)
		{
			_textBox_mc.htmlText = _textShown[_currentIndex];
		}

		//Cargo el sonido iésimo
		_level0.sonidoError = false;
		if(_audioActivado)
		{
			_sonido.loadSound(_locuciones[_currentIndex], true); //Lo cargo como streaming
			this.gSincro._padre.gEvAct.Notificar(_sonido,"COMIENZO_AUDIO");
		}

		if(_debug) trace ("longitud locuciones" + locuciones.lenght + "longitud Text shown" + _textShown.length);
		
		var scope:Object = this;
		_sonido.onSoundComplete = function (){
			scope.finAudio();
			//Faraco 15-10-2008
			if(_level100.gAcces.gSincro.gSubtitulos.animarMascota){
				_level100.gAcces.gSincro.gSubtitulos._objRefuerzo.cargarAccion("parado");
			}
			//Fin Faraco 15-10-2008
		}
		_sonido.setVolume(volumen);
		if(_debug) trace("tocando : " + _locuciones[_currentIndex]);
		trace("terminado es: "+terminado);
		if (_textShown.length > 1) {
			_currentIndex++;
		}else{
			terminado = true;
		}
		if (repeticion){
			_currentIndex--;
			repeticion = false;
		}
		//El tiempo que iré estableciendo será el máximo entre la duración de la locución y el delay de subtítulos
//		_idTipBox = setInterval(this, "retrasar", delay);
		_iterador = 1;
//		loLlamaSetText = true;
		//_idTipBox = setInterval(this, "_setText", delay);
	}
	
	public function finAudio() {
		if ((_sonido.duration - _delay) < 0){
			if (terminadoParcial == false){
				if (_debug) trace("El tiempo que falta para terminar el audio es: "+ (_delay - _sonido.duration));
				_idTipBox = setInterval(this, "esperarSubtitulos", (_delay - _sonido.duration));
				if (_debug)trace("retrasando locución...");
			} else{
				terminadoParcial = false;
				//Aqui hay que notificar FIN DE AUDIO
				this.gSincro._padre.gEvAct.Notificar(_sonido,"FIN_AUDIO");
				comprobacion();
			}
		}
		else {
			if (_debug)trace("YA HA PASADO EL TIEMPO DE SUBTITULOS");
			_iterador = 1;
			//Aqui hay que notificar FIN DE AUDIO
			this.gSincro._padre.gEvAct.Notificar(_sonido,"FIN_AUDIO");
			comprobacion();
		}
	}
	public function comprobacion (){
		if (subtitulos){
			if (_debug)trace("Haz aqui una traza de terminado:"+terminado);
			//if(_debug) trace("Texto de este momento:"+_textBox_mc.htmlText);
			if(terminado){
					if(stopOnFinish==true){
						if (_limpiar != false){ 
							_limpiar = false;
							clear();
							_sonido.stop();
						}else{
							terminado=false;
						}
						onFinish();
						return;
					}
				}else{
					onFrase();
				}
			if(_subsActivados)
			{
				_textBox_mc.htmlText = _textShown[_currentIndex];
			}

			//Cargo el sonido iésimo
			_level0.sonidoError = false;
			if(_audioActivado)
			{
				this.gSincro._padre.gEvAct.Notificar(_sonido,"COMIENZO_AUDIO");
				_sonido.loadSound(_locuciones[_currentIndex], true); //Lo cargo como streaming
			}
			_sonido.setVolume(volumen);
			if(_debug) trace("tocando: " + _locuciones[_currentIndex]);
			if(_currentIndex == _textShown.length - 1){
				terminado = true;
				_currentIndex = 0;
			}else{
				_currentIndex++;
			}
		}
	}
	
	public function esperarSubtitulos() {
		trace("estoy en espera de subtitulos");
		clearInterval(_idTipBox);
		terminadoParcial = true;
		finAudio();
	}
	public function clear() {
		_textBox_mc.htmlText = "";
		_sonido.stop();
		//if (_idTipBox > 0)
			//clearInterval(_idTipBox);
	}
/*	private function retrasar() {
		clearInterval(_idTipBox);
		if(_debug) trace("retrasando (" + _sonido.duration + ")");
		_retraso = _sonido.duration - _delay;
		if(_debug) trace("Retraso: " + _retraso);
		if (_retraso > 0)
			_idTipBox = setInterval(this, "_setText", _retraso);
		else
			_setText();
	}
*/
	
	private function _setText () {
		//Ahora siempre tendré que hacer un clear Interval
//		clearInterval(_idTipBox);
//if(_debug) trace("ERROR??? " + _level0.sonidoError);
//if (loLlamaSetText == true){
		trace(_delay * _iterador);
		if (((_sonido.duration == 0) or (_sonido.duration > (_delay * _iterador))) and (not _level0.sonidoError))
		//if (((_sonido.duration == 0) or ((_sonido.duration - _delay) > (_delay * _iterador))) and (not _level0.sonidoError))
			trace("retrasando locución... (" + _iterador++ + ")");
		else {
			_iterador = 1;
			if (subtitulos){
				if(_debug) trace("Haz aqui una traza de terminado:"+terminado);
				//if(_debug) trace("Texto de este momento:"+_textBox_mc.htmlText);
				if(terminado){
					if(stopOnFinish==true){
						if (_idTipBox > 0){
							if (_limpiar != false){ 
								_limpiar = false;
								clear();
								//loLlamaSetText = false;
								_sonido.stop();
								clearInterval(_idTipBox);
							}
							onFinish();
	//					clear();
						}
						return;
					}else{
						terminado=false;
					}
					onFinish();
				}else{
					onFrase();
				}

				if(_subsActivados)
				{
					_textBox_mc.htmlText = _textShown[_currentIndex];
				}
	
				//Cargo el sonido iésimo
				_level0.sonidoError = false;
				if(_audioActivado)
				{
					_sonido.loadSound(_locuciones[_currentIndex], true); //Lo cargo como streaming
				}
				_sonido.setVolume(volumen);
				if(_debug) trace("tocando: " + _locuciones[_currentIndex]);
	
				if(_currentIndex == _textShown.length - 1){
					terminado = true;
					_currentIndex = 0;
				}else{
					_currentIndex++;
				}
				//El tiempo que iré estableciendo será siempre, como mínimo el delay de subtítulos
	//			_idTipBox = setInterval(this, "retrasar", _delay);
	//			_idTipBox = setInterval(this, "_setText", _delay);
			}
		}
//	}
	}	

	public function detener(){
		if(_debug) trace("deteniendo...");
		if (_idTipBox > 0){
			_sonido.stop();
			clearInterval(_idTipBox);
		}
	}
	
	public function resumir(){
		if(_debug) trace("resumiendo...");
//		if (_idTipBox > 0)
			clearInterval(_idTipBox);
//		_idTipBox = setInterval(this, "retrasar", _delay);
		_idTipBox = setInterval(this, "_setText", _delay);
	}

	//Faraco 26-11-08
	//Función activarSubs activa los subtítulos
	public function activarSubs()
	{
		_subsActivados = true;
	}

	//Función desactivarSubs desactiva los subtítulos
	public function desactivarSubs()
	{
		_subsActivados = false;
	}

	//Función activarAudio activa el audio
	public function activarAudio()
	{
		_audioActivado = true;
	}

	//Función desactivarAudio desactiva el audio
	public function desactivarAudio()
	{
		_audioActivado = false;
	}
	//Fin Faraco 26-11-08
}
