//clase estado
//Autor: Javier Cuesta Gonzlez de la Aleja
//esta clase ser utilizada por el gestorAutomata, cada estado 
//que tengamos en un automata ser de esta clase, en cada uno de
// los estados de nuestro autmata tendremos una lista de las 
//aristas de las que el propio estado es origen, un nombre del estado,
// si ha sido visitado (esto nos servir para pornerle un check) 
// y un identificador de la pregunta que se realizar en este estado

class estado{
	private var _listaAristas: Array;
	private var _nombre: String;
	private var _visitado: Boolean;
	private var _pregunta: String;
	
	
	public function estado (nombre:String, listaAristas:Array, pregunta:String){
		this._listaAristas = listaAristas;
		this._nombre = nombre;
		this._visitado = false;
		this._pregunta = pregunta;
		}
	
	public function GetNombre():String{
		return this._nombre;
		}
	
	public function GetVisitado():Boolean{
		return this._visitado;
		}
		
	public function PutVisitado(){
		this._visitado = true;
		}
	
	public function GetListaAristas():Array{
		return this._listaAristas;
		}
		
	public function GetPregunta():String{
		return this._pregunta;
		}
	
}