﻿import elementoActividad;

class gestorImagenes {
	var cargaClip:MovieClipLoader; //Cargador de imágenes
	var listenerCargaClip:Object; //Escuchador del cargador de imágenes
	var notificarA;
	//Gon 29-12-2006
	// El movieclip se debe inicializar en el constructor, que no existe
	// Nunca se llama a este método ConstruirCargaClip, por eso no funcionaba
	/*
	function ConstruirCargaClip() {
		this.cargaClip = new MovieClipLoader();
	}
	*/
	//Constructor de la clase
	function gestorImagenes(notificar_A) {
//		this.cargaClip.onLoadError = function () {trace("error");}
//		this.cargaClip.onLoadComplete = function () {trace("cargada");}
		this.notificarA = notificar_A;
		trace("MONTOY: " + notificarA);
		this.cargaClip = new MovieClipLoader();
		this.listenerCargaClip= new Object();
		listenerCargaClip.addProperty("notificarA");
		listenerCargaClip.notificarA = this.notificarA;
		this.listenerCargaClip.onLoadInit = function (target_mc) 
		{
			trace (target_mc + " CARGADO");
			this.notificarA.Notificar(target_mc, "FIN_CARGA");
		}
		this.listenerCargaClip.onLoadError = function (target_mc) 
		{
			trace ("NO se ha podido cargar " + target_mc);
		}
		this.cargaClip.addListener(this.listenerCargaClip);
	}
	//FIN Gon 29-12-2006	
	function cargarImagenes(arrayFicheros:Array, arrayNombres:Array):Array {
		trace("cargando imagenes...");
		if ( (arrayFicheros==null) || (arrayFicheros.length==0) ) {
			return null;
		}
		var arrayMovieClipsOut:Array = new Array(arrayFicheros.length);
		var nombre:String;
		for (var i:Number=0; i<arrayFicheros.length; i++) {
			if (arrayNombres == null) {
				nombre = "target"+i;
			} else {
				nombre = arrayNombres[i];
			}
//			_root.createEmptyMovieClip(nombre, _root.getNextHighestDepth());
			var nivel = eval(notificarA);
//			trace("MONTOY: "+ nivel);
			nivel.createEmptyMovieClip(nombre, nivel.getNextHighestDepth());
			arrayMovieClipsOut[i] = nivel[nombre];
			cargarImagen(arrayFicheros[i], nivel[nombre]);
			nivel[nombre]._visible = true;
			trace(nivel[nombre]+ "=" + arrayMovieClipsOut[i] + " es visible");
		}
		//FIN FOR
		trace("imagenes cargadas");
		return arrayMovieClipsOut;
	}
	//FIN cargarImagenes
	//Javier Cuesta 23-09-08
	function cargaImagenesElementos (lista : Array): Array {
		trace("cargando imagenes...");
		if ( (lista==null) || (lista.length==0) ) {
			return null;
		}
		var arrayMovieClipsOut:Array = new Array(lista.length);
		var nombre:String;
		var fichero:String;
		for (var i:Number=0; i<lista.length; i++) {
			nombre = lista[i].GetNombre();
			var nivel = eval(notificarA);
			nivel.createEmptyMovieClip(nombre, nivel.getNextHighestDepth());
			arrayMovieClipsOut[i] = nivel[nombre];
			fichero = lista[i].GetFichero();
			cargarImagen(fichero, nivel[nombre]);
			nivel[nombre]._visible = true;
			trace(nivel[nombre]+ "=" + arrayMovieClipsOut[i] + " es visible");
		}
		//FIN FOR
		trace("imagenes cargadas");
		return arrayMovieClipsOut;
	}
	//FIN Javier Cuesta 23-09-08
	function cargarImagen(imagen:String, destino:MovieClip):Void {
		trace(imagen);
		trace(destino._name+": ("+destino._x+","+destino._y+")");
		this.cargaClip.loadClip(imagen, destino);
	}
	//gap_horizontal y gap_vertical indican la distancia 
	//entre los origenes de cada movieclip en los ejes
	//x e y respectivamete
	function generaMatrizImagenes(arrayMovieClips:Array, numFilas:Number, numColumnas:Number, origen_x:Number, origen_y:Number, gap_horizontal:Number, gap_vertical:Number, mc_width:Number, mc_height:Number) {
		//generaMatrizImagenes
		var temp_x = origen_x;
		var temp_y = origen_y;
		var index = 0;
		for (var i=0; (index<arrayMovieClips.length) && (i<numFilas); i++) {
			for (var j=0; (index<arrayMovieClips.length) && (j<numColumnas); j++, index++) {
				arrayMovieClips[index]._x = temp_x;
				arrayMovieClips[index]._y = temp_y;
				if (mc_width!=0)
				{
					arrayMovieClips[index]._xscale = mc_width;
				}
				if (mc_height!=0)
				{
					arrayMovieClips[index]._yscale = mc_height;
				}
				trace(arrayMovieClips[index]+": ("+arrayMovieClips[index]._x+","+arrayMovieClips[index]._y+")");
				trace(arrayMovieClips[index]+"pixeles: ("+arrayMovieClips[index]._width+","+arrayMovieClips[index]._height+")");
				temp_x += gap_horizontal;
			}
			temp_x = origen_x;
			temp_y += gap_vertical;
		}
	}
	//generaMatrizImagenes
	//Genera un array de números de forma aleatoria de tamaño arrayMovieClips.length
	function cargaArrayRandom(arrayMovieClips:Array):Array {
		var tam:Number = arrayMovieClips.length;
		if (arrayMovieClips.length == 0) {
			return null;
		}
		//Para cargar el array de datos aleatorios
		var arrayTemp:Array = Array(tam);
		var arrayMovieClipsRandomOut:Array = new Array(tam);
		for (var i=0; i<tam; i++) {
			arrayTemp[i] = i;
		}
		for (var i=0; i<tam; i++) {
			var temp = random(arrayTemp.length);
			arrayMovieClipsRandomOut[i] = arrayMovieClips[arrayTemp[temp]];
			arrayTemp.splice(temp, 1);
			//le quito el valor usado
		}
		return arrayMovieClipsRandomOut;
	}
	
	//OrdenarMatrizMC
	//genera una matriz seugn el orden nuevo que le hemos dado
	function OrdenarMatrizMC(arrayMC:Array,arrayNuevoOrden:Array):Array{
		var arrayMCOrdenado:Array=new Array();
		var mc:MovieClip;
		for(var i=0;i<arrayNuevoOrden.length;i++){
			mc=Buscar(arrayMC,arrayNuevoOrden[i]);
			arrayMCOrdenado[i]=mc;
			}
		return arrayMCOrdenado;
		}//fin OrdenarMatrizMC
	
	//Buscar
	//busca el movie clip asociado al nombre en ese array.
	function Buscar(arrayMC:Array, nombre:String):MovieClip{
		for (var i=0;i<arrayMC.length;i++){
			if(arrayMC[i]._name==nombre){
				return arrayMC[i];
				}
			}
		}//fin Buscar
	
}//FIN class
